//////////////////////////////////////////////////////////////////////////////////////////////////
//Programmer:		Jason Bouchard
//Project:		Project 2
//Course:		CS 343
//Description:   
//			Recursive - Descent Parser to parse and evaluate arithmetic expressions 
//			involving integer constants.	
//
//Compile Instructions: javac Scanner.java
//Execution Instructions: Non executable.  No main method.
//////////////////////////////////////////////////////////////////////////////////////////////////


import java.lang.*;
	public class Scanner
	{
		Token currentToken;
		String line;
		int currentPos;

		public Scanner(String line)
		{
			this.line = line;
			currentPos = 0;
		}
		
		//returns the current token.
		public Token CurrentToken()
		{
			return currentToken;
		}

		public void NextToken()
		{
			//gets the next token.
			int numval;
			currentToken = new Token();

			// skip blanks if any
			while (currentPos < line.length() && line.charAt(currentPos) == ' ')
			{
				currentPos++;
			}

			if (currentPos < line.length())
			{
				if (Character.isDigit(line.charAt(currentPos))) 
				{
					numval = 0;
					while (currentPos < line.length() && Character.isDigit(line.charAt(currentPos)))
					{
						numval = 10 * numval + line.charAt(currentPos) - '0';
						currentPos++;
					}
					currentToken.settkType(Token.NUMBER);
					currentToken.settkValue(numval);
				} 
				else 
				{
					switch(line.charAt(currentPos)) 
					{
						case '(':
							currentToken.settkType(Token.LPAREN);
							currentToken.settkValue('(');

							break;
						case ')':
							currentToken.settkType(Token.RPAREN);
							currentToken.settkValue(')');

							break;						

						case '+':
							currentToken.settkType(Token.PLUS);
							currentToken.settkValue('+');
							break;						

						case '-':
							currentToken.settkType(Token.MINUS);
							currentToken.settkValue('-');
							break;						

						case '*':
							currentToken.settkType(Token.MULT);
							currentToken.settkValue('*');
							break;						

						case '/':
							currentToken.settkType(Token.DIVIDE);
							currentToken.settkValue('/');
							break;						

						case '%':
							currentToken.settkType(Token.REMAINDER);
							currentToken.settkValue('%');
							break;

						case '^':
							currentToken.settkType(Token.POWER);
							currentToken.settkValue('^');
							break;						

						default:
							currentToken.settkType(Token.ERROR);
							currentToken.settkValue(Token.ERROR);
							break;						

					}
					currentPos++;
				}
			}
			else
			{
							currentToken.settkType(Token.EOL);
							currentToken.settkValue(Token.EOL);
									

			}
		}
	}

